var cacheToCss = require('./cache-to-css');
var StyletronCore = require('styletron-core');

/**
 * StyletronServer
 * @extends StyletronCore
 */
var StyletronServer = (function (StyletronCore) {
  function StyletronServer() {
    StyletronCore.call(this);
    this.injectionCount = 0;
  }

  if ( StyletronCore ) StyletronServer.__proto__ = StyletronCore;
  StyletronServer.prototype = Object.create( StyletronCore && StyletronCore.prototype );
  StyletronServer.prototype.constructor = StyletronServer;

  StyletronServer.prototype.injectDeclaration = function injectDeclaration (decl) {
    this.injectionCount++;
    return StyletronCore.prototype.injectDeclaration.call(this, decl);
  };

  /**
   * Get the CSS string of cache
   * @return {String} The string of CSS
   * @example
   * const styletron = new StyletronServer();
   *
   * styletron.injectDeclaration({prop: 'color', val: 'red'});
   * // ➜ 'c0'
   * styletron.getCss();
   * // ➜ '.c0{color:red}'
   */
  StyletronServer.prototype.getCss = function getCss () {
    return cacheToCss(this.cache);
  };

  StyletronServer.prototype.getInjectionCount = function getInjectionCount () {
    return this.injectionCount;
  };

  return StyletronServer;
}(StyletronCore));

module.exports = StyletronServer;
